#!/bin/bash

#CREATEPEDIG=$PWD/../bin/cpedig
CREATEPEDIG=$PWD/bin/create_pedig

LDSO=$PWD/bin/ldso
QTLMAP=/home/ofilangi/workspace-new/QTLMap-RedMine/build/release/src/qtlmap

#TO generate only dataset and qtlmap file without execution....
ACTIVE_QTLMAP="OK" # "OK" ou "KO"

# Nombre de simulation LDSO + QTLMAP
NSIM=200

#Nombre de simulation QTLMAP
NSIM_SEUIL_QTLMAP=1000
LONG_CHROMO=1.0
NB_MARKER=200
POS_QTL=0.5
EFF_QTL=1.0

GPU_ID=0
#OPT_QTLMAP="--haplotype=0"

H2=0.5
RATIO_POLQTL=0.05

NG=5         # Nombre de generation
NMPED=5       # Nombre de male
NFMPED=4     # Nombre de femelle par pere
NDFPED=10     # Nombre de descendant par femelle par generation historique
NMQTL=5     # Nombre de male dans le protocole QTL
NFMQTL=10     # Nombre de femelle par pere dans le protocole QTL
NDFQTL=10    # Nombre de descendant par femelle par generation historique dans le protocole QTL

QTLMAP_STEP=0.01

#analyse demi-frere
QTLMAP_NDMIN=25
QTLMAP_H2=$H2

export OMP_NUM_THREADS=4

RATIO_POLQTL=0.05
source ./workflow_ldso_qtlmap_cal.sh 29 "--haplotype=0 --hdam"
source ./workflow_ldso_qtlmap_cal.sh 25 "--haplotype=0 --hdam"
source ./workflow_ldso_qtlmap_cal.sh 3 "--haplotype=0"

