#!/bin/bash

# script qui genere les fichier ldso 
# 
# 1 qtl/fichier de genealogie connu

source $ROOTDIR/functions.sh

############### FICHIER TEMPORAIRES - EFFACEMENT DES RELIQUATS ==============================================

rm -rf general pop1 popfin files param p_analyse typqtlmap mapqtlmap geneaqtlmap perfqtlmap modelqtlmap simperf simped simhaploNoQTL
rm -rf effects genotyp_err map parpop pedig simhaplo

############## GENERATION DU FICHIER PARAMETRE PARPOP POUR CREATE_PEDIG ======================================

echo "${NG} $NMPED $NFMPED $NDFPED $NMQTL $NFMQTL $NDFQTL">parpop
echo "${SEED_PEDIG}">>parpop


####################################### APPEL PEDIG =============================================================
$CREATEPEDIG
#######################################

FILE_PEDIG=pedig
#SIZE_PEDIG=$(($NMPED+$NFMPED*$NMPED+ $NG*$NFMPED*$NMPED + $NMQTL*NFMQTL*NDFQTL))
LAST_ID_PEDIG=`tail -n1 ${FILE_PEDIG} | awk '{print $1}'`
SIZE_PEDIG=${LAST_ID_PEDIG}
#=========================================================================================================


#file LDSO
#--------
GENERAL=general
POP1=pop1
POPFIN=popfin
FILES=files
PARAM=param


#--------------- general -------------------------


echo "${LONG_CHROMO}  1  !  # total length genome in M ,  chrom">$GENERAL
echo "${NB_MARKER}    ! # markers">>$GENERAL
echo "1       ! # QTL">>$GENERAL
echo "0">>$GENERAL
echo "0 0           ! nb qtl dominant, nb qtl_interaction">>$GENERAL
echo "2             ! stockage des origines de chaque allele">>$GENERAL
echo "0 0 0   ! creation /lecture de la carte, impression de A">>$GENERAL
echo "${EFF_QTL}">>$GENERAL
echo "2       !  2=>on donne la position des marqueurs et du qtl / 1 sinon">>$GENERAL
echo $((${NB_MARKER} + 1))"     ! maximum number of markers on one chromosome">>$GENERAL
echo $((${NB_MARKER} + 1))"     ! nombre de locus sur le premier chromo">>$GENERAL
# les marqueurs. ajouter a la main l
for ((i = 0; i <= ${NB_MARKER}; i += 1));do echo $i;done | awk '\
BEGIN {ok="f";pas='${LONG_CHROMO}'/'${NB_MARKER}'} \
'${POS_QTL}'> $1*pas {printf("%f 0\n", $1*pas)}\
'${POS_QTL}'<= $1*pas && ok!="f" {printf("%f 0\n", $1*pas) }\
'${POS_QTL}'<= $1*pas && ok=="f" {printf("%f 1\n", $1*pas) ; ok="t"; }\
'>>$GENERAL
echo "1     ! only SNP" >>$GENERAL
echo "0.0001 0.0001 0.0001 ! Mutation rates">>$GENERAL
echo "0     ! Initial LD">>$GENERAL
echo "0" >>$GENERAL


#--------------- pop1 -------------------------


echo "1 !number of population">$POP1
echo "0 !number of bottleneck">>$POP1
echo "100 100 1. 1.">>$POP1
echo "0 !qtl fixe dans la premiere  pop">>$POP1
for ((i = 1; i <= ${NB_MARKER}; i += 1));do echo "1">>$POP1;done
echo "2 1 ">>$POP1
echo "${H2}">>$POP1
echo "${RATIO_POLQTL}">>$POP1
echo "0">>$POP1
echo "0">>$POP1
echo "1">>$POP1
echo "${FILE_PEDIG} ${SIZE_PEDIG}">>$POP1
echo "${LAST_ID_PEDIG}">>$POP1


#--------------- popfin -------------------------

echo "3">${POPFIN}
echo "0">>${POPFIN}

#--------------- file ---------------------------

echo "2 1">${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}
echo "n">>${FILES}

# ------------- param ----------------------------

echo "${SEED1} ${SEED2} ${SEED3}">$PARAM
#============================================================================================================

######################## APPEL LDSO ###########################

$LDSO


###################################################

############## FICHIER PERF QTLMAP
cat simperf | awk '{print $1" "$2" 1 1"}' > perfqtlmap

############## FICHIER MAP QTLMAP
#touch mapqtlmap
#rm mapqtlmap
#touch mapqtlmap
#for ((i = 0; i <= ${NB_MARKER}; i += 1));do echo "SNP$i $1 1 "|awk 'BEGIN {pas='${LONG_CHROMO}'/'${NB_MARKER}'} { print $0" "'$i'*pas" "'$i'*pas" "'$i'*pas" 1"}'>>mapqtlmap;done

cat map | awk 'BEGIN {v=1} $5 == "0" {print "SNP"v" "$2" "$4" "$4" "$4" 1";v++}'>mapqtlmap


#on verifie l'heterozigocie des peres
IND_MARK=`cat map | awk '$5 == "1"{print (NR+1)}'`
IDPERES=`cat pedig | awk '$4 =="1"{print $0}' | awk 'NR <= '$NMQTL' {print $1}'`
nbhetero=0
echo "IDPERES:" $IDPERES
for ID in $IDPERES
do
 nbhetero=$(( $nbhetero + `cat simhaplo | awk ' "'$ID'"==$1 && $2=="1" {v1=$'$IND_MARK'} "'$ID'"==$1 && $2=="2" {v2=$'$IND_MARK'} END { if (v1==v2) {print "0"} else {print "1"}; }'`))
done
echo "Nombre de pere hetero : "$nbhetero

############# FICHIER TYPAGE

#NUMSNPQTL=`cat map | awk '$5 == "1" { print $1 }'`

cat simhaploNoQTL | awk 'BEGIN {nb=0} NR == 1 { v="SNP1" ; for (i=2;i<=(NF-2);i++) {v=v" SNP"i}; print v;} { if ($2 == 1) {nb++}; for (i=3;i<=NF;i++) {all[$2"-"$1"-"i]=$i;} ; nmk=NF} END { for (i=1;i<=nb;i++) {v=i" ";for(j=1;j<=nmk;j++) { v=v" "all["1-"i"-"j]" "all["2-"i"-"j] } print v;} }'  > typqtlmap


modelqtlmap_file ${QTLMAP_H2}
panalyseqtlmap_file ${QTLMAP_STEP} ${QTLMAP_NDMIN}

clean_ldso

