#!/bin/bash

#model file
modelqtlmap_file() {

v_QTLMAP_H2=$1

echo "1">modelqtlmap
echo "0 0">>modelqtlmap
echo "bidonfix bidoncov">>modelqtlmap
echo "simultrait r 0 0">>modelqtlmap
echo "correlation_matrix">>modelqtlmap
echo "${v_QTLMAP_H2}">>modelqtlmap
}

#P_ANALYSE QTLMAP
panalyseqtlmap_file() {

v_QTLMAP_STEP=$1
v_QTLMAP_NDMIN=$2

echo "in_map=mapqtlmap">p_analyse
echo "in_genealogy=pedig">>p_analyse
echo "in_genotype=typqtlmap">>p_analyse
echo "in_traits=perfqtlmap">>p_analyse
echo "in_model=modelqtlmap">>p_analyse
echo "opt_step=${v_QTLMAP_STEP}">>p_analyse
echo "opt_ndmin=${v_QTLMAP_NDMIN}">>p_analyse
echo "opt_minsirephaseproba=0.90">>p_analyse
echo "opt_mindamphaseproba=0.10">>p_analyse
echo "opt_chromosome=1">>p_analyse
echo "opt_unknown_char=0">>p_analyse
echo "out_output=result">>p_analyse
echo "out_summary=summary">>p_analyse
echo "opt_gpu_device_id=$GPU_ID">>p_analyse
}


clean_qtlmap () {
  rm result_freqall result_phases result summary
}

clean_ldso() {
 rm simhaplo simhaploNoQTL simperf map simped
}
